'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CONFIG = {
  VIRTUAL_PAGE_TRACKING: true,
  SERVICES: {
    SPLUNK: 'avSplunkAnalytics'
  },
  EVENTS: {
    PAGE: '$locationChangeSuccess',
    DEFAULT: 'click'
  },
  PRE_FIX: /^avAnalytics(.*)$/,
  // should ignore these since they are part of the directives API
  IGNORE: ['avAnalyticsOn', 'avAnalyticsIf']
};

var AvAnalyticsConfigProvider = function () {
  function AvAnalyticsConfigProvider() {
    _classCallCheck(this, AvAnalyticsConfigProvider);

    this.options = CONFIG;
  }

  _createClass(AvAnalyticsConfigProvider, [{
    key: 'get',
    value: function get() {
      return _angular2.default.copy(this.options);
    }
  }, {
    key: 'set',
    value: function set(options) {
      _angular2.default.merge(this.options, options);
    }
  }, {
    key: '$get',
    value: function $get() {
      return _angular2.default.copy(this.options);
    }
  }]);

  return AvAnalyticsConfigProvider;
}();

_module2.default.provider('avAnalyticsConfig', AvAnalyticsConfigProvider);

exports.default = _module2.default;