'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('../../core/api/logs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_module2.default.factory('avSplunkAnalytics', function ($log, avLogMessagesResource, $location) {
  var SplunkAnalyticsService = function () {
    function SplunkAnalyticsService() {
      _classCallCheck(this, SplunkAnalyticsService);
    }

    _createClass(SplunkAnalyticsService, [{
      key: 'trackEvent',
      value: function trackEvent(properties) {

        properties.url = $location.$$absUrl || 'N/A';
        properties.level = properties.level || 'info';

        return avLogMessagesResource[properties.level](properties);
      }
    }, {
      key: 'trackPageView',
      value: function trackPageView(url) {

        var properties = {
          event: 'page',
          level: 'info',
          url: url || $location.$$absUrl()
        };

        return avLogMessagesResource[properties.level](properties);
      }
    }, {
      key: 'isEnabled',
      value: function isEnabled() {
        return true;
      }
    }]);

    return SplunkAnalyticsService;
  }();

  return new SplunkAnalyticsService();
});

exports.default = _module2.default;