'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('./config');

require('./constants');

require('./validators');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvValProvider = function () {
  function AvValProvider() {
    _classCallCheck(this, AvValProvider);

    this.validators = [];
    this.rules = {};
    this.services = {};
  }

  _createClass(AvValProvider, [{
    key: 'addRules',
    value: function addRules(_rules) {
      this.rules = _angular2.default.extend({}, this.rules, _rules);
      return this.rules;
    }
  }, {
    key: 'addValidators',
    value: function addValidators(_validators) {
      this.validators = this.validators.concat(_validators);
      return this.validators;
    }
  }, {
    key: '$get',
    value: function $get($injector, $rootScope, avValConfig, AV_VAL) {

      var that = this;

      var AvValidation = function () {
        function AvValidation() {
          _classCallCheck(this, AvValidation);

          this.initValidators();
        }

        _createClass(AvValidation, [{
          key: 'initValidators',
          value: function initValidators() {

            var self = this;

            that.validators = avValConfig.validators.concat(that.validators);

            _angular2.default.forEach(that.validators, function (name) {
              self.addValidator(name);
            });
          }
        }, {
          key: 'addValidator',
          value: function addValidator(name) {
            var validator = $injector.get(name);
            that.services[validator.name] = validator;
          }
        }, {
          key: 'addRules',
          value: function addRules(rules) {
            that.rules = _angular2.default.extend({}, that.rules, rules);
            $rootScope.$broadcast(AV_VAL.EVENTS.REVALIDATE);
          }
        }, {
          key: 'getRule',
          value: function getRule(key) {
            return that.rules[key];
          }
        }, {
          key: 'getService',
          value: function getService(name) {
            return that.services[name];
          }
        }]);

        return AvValidation;
      }();

      return new AvValidation();
    }
  }]);

  return AvValProvider;
}();

_module2.default.provider('avVal', AvValProvider);