'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('velocity-animate');

require('velocity-animate/velocity.ui');

var _template = require('./template.html');

var _template2 = _interopRequireDefault(_template);

var _module = require('../../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvLoaderController = function () {
  function AvLoaderController($element) {
    _classCallCheck(this, AvLoaderController);

    this.endAnimation = function () {
      this.av.$element.find('.loading-bullet').velocity('stop', true);
      this.av.$element.removeData();
    };

    this.av = { $element: $element };

    this.active = false;
  }

  _createClass(AvLoaderController, [{
    key: 'start',
    value: function start() {
      this.active = true;
      this.animate();
    }
  }, {
    key: 'animate',
    value: function animate() {

      var self = this;

      this.av.$element.find('.loading-bullet').velocity('transition.slideRightIn', { stagger: 250 }).velocity({ opacity: 0 }, {
        delay: 750,
        duration: 500,
        complete: function complete() {
          if (self.active) {
            setTimeout(function () {
              self.animate();
            }, 500);
          } else {
            self.endAnimation();
          }
        }
      });
    }
  }, {
    key: '$destroy',
    value: function $destroy() {
      this.active = false;
    }
  }, {
    key: '$postLink',
    value: function $postLink() {
      this.start();
    }
  }]);

  return AvLoaderController;
}();

_module2.default.directive('avLoader', function () {
  return {
    restrict: 'AE',
    replace: true,
    controller: AvLoaderController,
    templateUrl: _template2.default
  };
});

exports.default = _module2.default;