'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var AvBlockContainerDirective = function () {
  function AvBlockContainerDirective(avBlockConfig) {
    _classCallCheck(this, AvBlockContainerDirective);

    this.av = { avBlockConfig: avBlockConfig };

    this.scope = true;
    this.restrict = 'AE';

    this.templateUrl = this.av.avBlockConfig.templateUrl;
  }

  _createClass(AvBlockContainerDirective, [{
    key: 'controller',
    value: function controller($scope, $element) {

      var service = $element.inheritedData('av-block');

      if (!service) {
        throw new Error('No parent av-block service instance located.');
      }

      // add state to scope of this directive
      $scope.state = service.state();
    }
  }]);

  return AvBlockContainerDirective;
}();

_module2.default.directive('avBlockContainer', function (avBlockConfig) {
  return new AvBlockContainerDirective(avBlockConfig);
});