'use strict';

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_module2.default.directive('avOnFileChange', function () {
  return {
    restrict: 'A',
    link: function link(scope, element, attrs) {
      element.on('change', function () {
        scope.$applyAsync(function () {
          var onFileChangeHandler = scope.$eval(attrs.avOnFileChange);
          var el = element[0];

          if (el.files) {
            onFileChangeHandler(scope, el);
            el.value = '';
          }
        });
      });

      scope.$on('$destroy', function () {
        element.off('change');
      });
    }
  };
});