'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('./constants');

require('./adapter-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

_module2.default.provider('avValAdapter', function () {

  var that = this;

  this.setAdapter = function (adapter) {
    this.adapter = adapter;
  };

  this.$get = function (AV_VAL_ADAPTER, $injector) {
    var Adapter = function () {
      function Adapter() {
        _classCallCheck(this, Adapter);

        var adapterName = that.adapter || AV_VAL_ADAPTER.DEFAULT;
        this.adapter = $injector.get(adapterName);
      }

      _createClass(Adapter, [{
        key: 'element',
        value: function element(context) {
          this.adapter.element(context);
        }
      }, {
        key: 'reset',
        value: function reset(element) {
          this.adapter.reset(element);
        }
      }, {
        key: 'message',
        value: function message(context) {
          this.adapter.message(context);
        }
      }, {
        key: 'scroll',
        value: function scroll(form) {
          this.adapter.scroll(form);
        }
      }]);

      return Adapter;
    }();

    return new Adapter();
  };
});