'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

require('./resource');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LogMessagesProvider = function () {
  function LogMessagesProvider() {
    _classCallCheck(this, LogMessagesProvider);
  }

  _createClass(LogMessagesProvider, [{
    key: '$get',
    value: function $get(AvApiResource) {
      var AvLogMessagesResource = function (_AvApiResource) {
        _inherits(AvLogMessagesResource, _AvApiResource);

        function AvLogMessagesResource() {
          _classCallCheck(this, AvLogMessagesResource);

          return _possibleConstructorReturn(this, (AvLogMessagesResource.__proto__ || Object.getPrototypeOf(AvLogMessagesResource)).call(this, {
            version: '/v1',
            name: '/log-messages'
          }));
        }

        _createClass(AvLogMessagesResource, [{
          key: 'requestPayload',
          value: function requestPayload(level, entries) {

            var payload = {};

            if (entries.level) {
              delete entries.level;
            }

            payload.level = level;
            payload.entries = entries;

            return payload;
          }
        }, {
          key: 'debug',
          value: function debug(entries) {
            return this.create(this.requestPayload('debug', entries));
          }
        }, {
          key: 'info',
          value: function info(entries) {
            return this.create(this.requestPayload('info', entries));
          }
        }, {
          key: 'warn',
          value: function warn(entries) {
            return this.create(this.requestPayload('warn', entries));
          }
        }, {
          key: 'error',
          value: function error(entries) {
            return this.create(this.requestPayload('error', entries));
          }
        }]);

        return AvLogMessagesResource;
      }(AvApiResource);

      return new AvLogMessagesResource();
    }
  }]);

  return LogMessagesProvider;
}();

_module2.default.provider('avLogMessagesResource', LogMessagesProvider);

exports.default = _module2.default;