'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AvUserPermissionsResourceFactory = function AvUserPermissionsResourceFactory(AvApiResource) {
  var AvUserPermissionsResource = function (_AvApiResource) {
    _inherits(AvUserPermissionsResource, _AvApiResource);

    function AvUserPermissionsResource() {
      _classCallCheck(this, AvUserPermissionsResource);

      return _possibleConstructorReturn(this, (AvUserPermissionsResource.__proto__ || Object.getPrototypeOf(AvUserPermissionsResource)).call(this, {
        path: '/api/sdk/platform',
        name: 'permissions'
      }));
    }

    _createClass(AvUserPermissionsResource, [{
      key: 'afterQuery',
      value: function afterQuery(response) {
        return response.data.permissions ? response.data.permissions : [];
      }
    }, {
      key: 'getPermissions',
      value: function getPermissions(permissionIds, region) {

        return this.query({
          params: {
            permissionId: permissionIds,
            region: region
          }
        });
      }
    }]);

    return AvUserPermissionsResource;
  }(AvApiResource);

  return new AvUserPermissionsResource();
};

_module2.default.factory('avPermissionsResource', AvUserPermissionsResourceFactory);

exports.default = _module2.default;