'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _module = require('../module');

var _module2 = _interopRequireDefault(_module);

var _angular = require('angular');

var _angular2 = _interopRequireDefault(_angular);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CONFIG = {
  animationConfig: {
    duration: 250
  },
  showAnimation: 'transition.fadeIn',
  showEvent: 'mouseenter',
  hideAnimation: 'transition.fadeOut',
  hideEvent: 'mouseleave',
  overlaySelector: '.dimmer-content'
};

var AvDimmerConfig = function () {
  function AvDimmerConfig() {
    _classCallCheck(this, AvDimmerConfig);

    this.options = CONFIG;
  }

  _createClass(AvDimmerConfig, [{
    key: 'get',
    value: function get() {
      return _angular2.default.copy(this.options);
    }
  }, {
    key: 'set',
    value: function set(options) {
      _angular2.default.extend(this.options, options);
    }
  }, {
    key: '$get',
    value: function $get() {
      return _angular2.default.copy(this.options);
    }
  }]);

  return AvDimmerConfig;
}();

_module2.default.provider('avDimmerConfig', AvDimmerConfig);

exports.default = _module2.default;